/*
- 1.0
:  
*/
#include "BaseWindowClass.h"
#include "resource.h"

//-----------------------------------------------------------------------

BaseWindowClass::BaseWindowClass() {}

//-----------------------------------------------------------------------

BaseWindowClass::~BaseWindowClass()
{
	//  
	UnregisterClass("BaseWindow", baseWndClass.hInstance);
}

//-----------------------------------------------------------------------

bool BaseWindowClass::Create(HINSTANCE hInstance, LPSTR szTitle,
				DWORD iStyle, int iWidth, int iHeight)
{
	//     
	baseWndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	baseWndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
	baseWndClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	baseWndClass.hInstance = hInstance;
	baseWndClass.lpfnWndProc = WndProc;
	baseWndClass.lpszClassName = "Base Window";
	baseWndClass.lpszMenuName = NULL;
	baseWndClass.cbClsExtra = 0;
	baseWndClass.cbWndExtra = 0;
	baseWndClass.style = 0;
	
	//   
	if(!RegisterClass(&baseWndClass))
	{
		//  ,  
		ExceptionBase e(CLASSREGISTRATIONERROR, "   ");
		throw e;
	}
	
	//  
	baseHWindow = CreateWindow("Base Window", szTitle, iStyle,
							CW_USEDEFAULT, CW_USEDEFAULT,
							iWidth, iHeight, NULL, NULL,
							hInstance, (void*)this);
	//    
	if(baseHWindow == NULL)
	{
		ExceptionBase e(WINDOWCREATIONERROR, "   ");
		throw e;
	}
	//      
	if(!SetWindowText(baseHWindow, szTitle))
	{
		//  ,  
		ExceptionBase e(SETTITLEERROR, "      ");
		throw e;
	}

	return 0;
}

//-----------------------------------------------------------------------

LRESULT CALLBACK BaseWindowClass::WndProc(HWND hWindow,
				UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	//     
	BaseWindowClass *baseWnd = NULL;
	bool beProcessed = false;
	
	//  
	switch(iMessage)
	{
		//     
		case WM_NCCREATE:
			//     ,   
			//(lParam)  (  ,   
			// )
			SetWindowLong(hWindow, GWL_USERDATA,
				(long)(LPCREATESTRUCT(lParam)->lpCreateParams));
			break;
		default:
			//     
			baseWnd = (BaseWindowClass*)GetWindowLong(hWindow,
										GWL_USERDATA);
			if(baseWnd != NULL)
			{
				//    
				beProcessed = baseWnd->MessageHandler(iMessage,
											wParam, lParam);
			}
			break;
	}
	//     ...
	if(beProcessed == false)
	{
		//...   
		return DefWindowProc(hWindow, iMessage, wParam, lParam);
	}
	return 0;
}

//-----------------------------------------------------------------------

void BaseWindowClass::Run()
{
    MSG msg; 
    ZeroMemory( &msg, sizeof(msg) );
  	//    
    while( msg.message!=WM_QUIT )
    {
		    //  
        if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
        {
			      // 
            TranslateMessage( &msg );
            DispatchMessage( &msg );
        }
        else
			      // 
            Render();
    }
}

//-----------------------------------------------------------------------

bool BaseWindowClass::MessageHandler(UINT iMessage,
						WPARAM wParam, LPARAM lParam)
{
	//  
	switch(iMessage)
	{
		//     ...
		case WM_DESTROY:
			//... 
			PostQuitMessage(0);
			return true;
		default:
			return false;
	}
}
//-----------------------------------------------------------------------
