/*
- 1.0
:  
*/
#include "ExceptionBase.h"
#include <string.h>

ExceptionBase::ExceptionBase(ExceptionBase& eb)
{
	errorCode = eb.getErrorCode();
	int len = strlen(eb.getErrorMessage());
	errorMessage = new char[len + 1];
	strcpy(errorMessage, eb.getErrorMessage());
}

ExceptionBase::ExceptionBase(int eC, const char *eM)
{
	errorCode = eC;
	int len = strlen(eM);
	errorMessage = new char[len + 1];
	strcpy(errorMessage, eM);
}

ExceptionBase::~ExceptionBase()
{
	if(errorMessage != NULL)
		delete [] errorMessage;
}

ExceptionBase& ExceptionBase::operator=(ExceptionBase& eb)
{
	if(this == &eb)
		return *this;
	delete [] errorMessage;
	errorCode = eb.getErrorCode();
	int len = strlen(eb.getErrorMessage());
	errorMessage = new char[len + 1];
	strcpy(errorMessage, eb.getErrorMessage());
	return *this;
}

int ExceptionBase::getErrorCode()
{
	return errorCode;
}

const char* ExceptionBase::getErrorMessage()
{
	return errorMessage;
}

ExceptionBase::operator int()
{
	return errorCode;
}

ExceptionBase::operator const char*()
{
	return errorMessage;
}
