/*
- 1.0
:  
*/
#ifndef _XZFIELD_H_
#define _XZFIELD_H_

#include <windows.h>
#include <math.h>
#include "ExceptionBase.h"
#include "Errors.h"

class XZField
{
private:
	int *data; // (33  ),    
	int *possibleMoves; //      
	//      (   )
	//    ,     (
	//   directions),     -   "-1"
	int winCol, winRow, winDirection;

	/*     possibleMoves ,
	  .    possibleMoves
	    data. ..   
	row = 1, col = 2   5 (  33).
	     ,      ,  
	,      .
	          i- , 
	     "10 ^ (recursionDepth - recNumber)".
	          i- , 
	     "(-1) * (10 ^ (recursionDepth - recNumber))".
	f -       ,
	recNumber -  ,
	startRow, startCol -    ( ),
possibleMoves - ,     */
	void analyseMove(XZField *f, int recNumber, int startRow, int startCol,
						int *posMoves);

	/*     .
	       possibleMoves
	(    analyseMove).
	    true,    - false.*/
	bool selectMove(int &row, int &col);
public:
	//  
	enum Values {EMPTY = 0, CROSS, ZERO};

	XZField(); //
	XZField(const XZField &field); // 
	virtual ~XZField(); //
	
	//   (type)   (row, col)
	//        
	//     false
	//    true
	bool setElement(int type, int row, int col);
	
	// ,    (row, col)
	//        
	int getElement(int row, int col) const;

	/* true   , false -   .
	    winner   :
	  EMPTY - ,
	  CROSS - ,
	  ZERO - .*/
	bool isGameOver(int &winner);

	/*  .      row
	 col.   ,  true,    - false.*/
	bool findNextMove(int &row, int &col);
};

#endif
