/*
- 1.0
:  
*/
#ifndef _XZGAME_H_
#define _XZGAME_H_

#include "BaseWindowClass.h"
#include "XZMesh.h"
#include "NewGameMenu.h"
#include "XZField.h"
#include "ExceptionBase.h"
#include "Errors.h"

#include <d3d9.h>
#include <d3dx9.h>
#include <windows.h>

//     -,  
// ,    ..
class XZGame :
	public BaseWindowClass
{
private:
	XZMesh *cross; //
	XZMesh *zero;  //
	XZMesh *field; //  
	XZMesh *selection; // 
	NewGameMenu *gameMenu; // 
	XZField *player; // ()

	LPDIRECT3D9 pD3D; //   Direct3D
	LPDIRECT3DDEVICE9 pD3DDevice; //   Direct3D

	//,   
	enum states {NEW_GAME_MENU = 0, //   (  )
				 NEW_GAME_MENU_WIN, //  (  )
				 NEW_GAME_MENU_LOST,//  (  )
				 NEW_GAME_MENU_DRAW,// (  )
				 PLAYER_MOVE,       // ,  
				 COMP_MOVE};        // ,  
	//  
	int curState;

	float dx, dy; //  Direct3D   
	float clientWidth, clientHeight; //   

	D3DXVECTOR4 a, b, c, d; //  (),    
	D3DXVECTOR4 ab1, ab2; //,      
							//   
	D3DXMATRIX viewPortScaling; //    
	float stepX; //  (     )
	float xScreen, yScreen; // 
	int areaX, areaY; //     (areaX = areaY = -1 -  
					  //   )
	//    ,  
	// (    )
	float H, h, L, l, downBase, upBase, innerBase;

	// 
	D3DXMATRIX worldMatrix;
	// 
	D3DXMATRIX menuMatrix;

	//     
	void ReleaseAll();
	//    
	D3DXMATRIX setUpProjectionMatrix(const float near_plane, const float far_plane,
									const float fov_horiz, const float fov_vert);
	//       
	void setViewPortScalingMatrix();
	/*        
	       areaX, areaY,
	        ,      "-1",
	    true -     , false -   .*/
	bool checkCursorPosition(int xPos, int yPos);
	//  
	void startNewGame();
public:
	//
	XZGame(void);
	//
	virtual ~XZGame(void);
	//    Direct3D   
	void initD3DAndGameObjects();
	//    Direct3D
	void setMatricesAndRenderStates();
	//  
	virtual bool MessageHandler(UINT iMessage, WPARAM wParam,
								LPARAM lParam);
	//    
	virtual void Render();
};

#endif
