/*
- 1.0
:  
*/
//-----------------------------------------------------------

#include "XZMesh.h"

//-----------------------------------------------------------

//   mesh     fileName
void XZMesh::loadMesh(const char *fileName)
{
	//    
	if(fileName == NULL)
	{
		ExceptionBase err(MESHNOTSPECIFIEDERROR, "   ");
		throw err;
	}
	//  
	LPD3DXBUFFER matBuffer;
	//  mesh
	if(FAILED(D3DXLoadMeshFromX(fileName, D3DXMESH_SYSTEMMEM, pD3DDevice,
				NULL, &matBuffer, NULL, &matNumber, &pMesh)))
	{
		//  ,  
		char *mes = "   mesh: ";
		size_t mesLength = strlen(mes) + strlen(fileName);
		char *fullMes = new char[mesLength + 1];
		strcpy(fullMes, mes);
		strcat(fullMes, fileName);
		ExceptionBase err(MESHNOTFOUNDERROR, fullMes);
		delete [] fullMes;
		throw err;
	}

	//      
	D3DXMATERIAL *d3dxMat = (D3DXMATERIAL*)matBuffer->GetBufferPointer();
	//  
	pMaterials = new D3DMATERIAL9[matNumber];

	//   
	for(int i = 0; i < matNumber; i++)
	{
		pMaterials[i] = d3dxMat[i].MatD3D;
		pMaterials[i].Ambient = pMaterials[i].Diffuse;
	}

	//  
	matBuffer->Release();
}

//-----------------------------------------------------------

//
XZMesh::XZMesh(LPDIRECT3DDEVICE9 pD3DDev, const char *fileName) :
		pD3DDevice(pD3DDev), pMesh(NULL), pMaterials(NULL)
{
	// mesh
	loadMesh(fileName);
}

//-----------------------------------------------------------

//
XZMesh::~XZMesh(void)
{
	//  
	if(pMaterials != NULL)
		delete [] pMaterials;
	// mesh
	if(pMesh != NULL)
		pMesh->Release();
}

//-----------------------------------------------------------

//   mesh
void XZMesh::render()
{
	// mesh
	for(int i = 0; i < matNumber; i++)
	{
		pD3DDevice->SetMaterial(&pMaterials[i]);
		pMesh->DrawSubset(i);
	}
}

//-----------------------------------------------------------
